/****************************************************************************************

		DXF.H.h

		Copyright (c)1990 - 1999 MetaCreations. All rights reserved.

		Definitions shared by the C++ files and the resource definition files (.r)


		Author: Pierre-E

		Date:	7/16/99

		Revision History

		when		who			what & why
		==========	==========	======================================================
		08/31/99	cph			fix to use new import/export API
		8/20/99		cph			added include for I3DShScene.h

*****************************************************************************************/


#ifndef __PSK__
#define __PSK__

#include "MCCompObj.h"
#include "PSKDef.h"
#include "Basic3DImportExport.h"
#include "MCBasicTypes.h"
#include "APITypes.h"
#include "COMUtilities.h"
#include "I3DShScene.h"

#include <stdlib.h>
#include <stdio.h>

#include "IShComponent.h"
#include "I3DExVertexPrimitive.h"
#include "IPolymesh.h"
#include "IPolygon.h"
#include "IShTextureMap.h"
#include "I3DShShader.h"
#include "I3dExSkinable.h"
#include "BonesUtilities.h"
#include "SkiningTypes.h"
#include "I3dShAnimationMethod.h"
#include "I3DShTweener.h"
#include "I3DShKeyFrame.h"
#include "I3dShAnimation.h"
#include "PMapTypes.h"
#include "I3dShUtilities.h"
#include "COM3DUtilities.h"



extern const MCGUID CLSID_PSK;

class TPSKExporter : public TBasic3DExportFilter
{
public:
	STANDARD_RELEASE;

	// for 3D exporters elem maps to I3DShScene and subElem maps toI3DShTreeElement through QueryInterface
	virtual MCCOMErr 	MCCOMAPI DoExport	(IMCFile * file, I3DShScene* scene, I3DShTreeElement* fatherTree);
};


#endif
